from zona.models import Item, Metadata
from pathlib import Path
import frontmatter
from dacite import from_dict


def split_metadata(path: Path) -> tuple[Metadata, str]:
    post = frontmatter.load(str(path))
    meta = post.metadata
    metadata = from_dict(
        data_class=Metadata,
        data=meta,
    )
    return metadata, post.content


def discover(root: str, out_dir: str) -> list[Item]:
    root_path = Path(root)
    required_dirs = {"content", "static", "templates"}
    found_dirs = {p.name for p in root_path.iterdir() if p.is_dir()}
    missing = required_dirs - found_dirs
    assert not missing, f"Missing required directories: {', '.join(missing)}"

    items: list[Item] = []

    for subdir in required_dirs:
        base = root_path / subdir
        for path in base.rglob("*"):
            if path.is_file():
                print(f"{subdir}: {path.relative_to(root_path)}")
                if path.name.endswith(".md"):
                    pass
                    # page = Frontmatter.read_file(path.name)
                # TODO: build Item here
                # items.append(...)
    return items
